﻿Public Class Form1

    '*************************************************************
    ' 定数定義
    '*************************************************************

    Const s_cstTITLE As String = "メール送信" 'メッセージボックスのタイトル用

    '*************************************************************
    ' プログラム起動
    '*************************************************************

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        '/////////////////////////////////////////////////////////////
        '// STARFAX インストール確認

        If AxSFCSEnv1.CheckInstall() <> SFCSENV_SUCCESS Then
            MsgBox("STARFAX がインストールされていない、" & vbCrLf & "もしくは STARFAX 環境設定プログラム でフォルダ環境が設定されていません。", MsgBoxStyle.Critical, s_cstTITLE)
            Me.Close()
            End
        End If

        '/////////////////////////////////////////////////////////////
        '// STARFAX サブフォルダ確認 (メール送信命令フォルダ

        If AxSFCSEnv1.CheckSubFolder(SFCSENV_SMODE_EMSMIS) <> SFCSENV_SUCCESS Then
            MsgBox("メール送信命令フォルダが存在しません。" & vbCrLf & "STARFAX を１度起動することにより、" & vbCrLf & "メール送信命令フォルダが作成されます。", MsgBoxStyle.Critical, s_cstTITLE)
            Me.Close()
            End
        End If

        '/////////////////////////////////////////////////////////////
        '// STARFAX サービス状態取得

        If AxSFCSEnv1.CheckServiceStatus() = SFCSENV_SERVICE_STOP Then
            MsgBox("STARFAX が動作していないので、" & vbCrLf & "メール送信命令ファイルを作成しても、実際にメール送信動作は行われません。", MsgBoxStyle.Exclamation, s_cstTITLE)
        End If


    End Sub

    '*************************************************************
    ' メール送信ボタン: クリック
    '*************************************************************

    Private Sub CommandOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CommandOK.Click

        Dim i As Object

        Dim strSubject As String
        Dim strTheBody As String
        Dim strAttachTEMP As String

        Dim lRet As Integer

        '  件名
        strSubject = TextSUBJECT.Text

        ' 本文
        strTheBody = TextTHEBODY.Text

        '/////////////////////////////////////////////////////////////
        '// (1)  宛先設定
        '//
        '// SFCSSendMailコントロール 《 宛先リストリセット 》
        '//   Sub ResetToInfo()
        '//
        '// SFCSSendMailコントロール 《 宛先リスト追加設定 》
        '//   Function AddToInfo( ToAddress As String ) as Long
        '//

        AxSFCSSendMail1.ResetToInfo()

        If TextTO.Text <> "" Then

            lRet = AxSFCSSendMail1.AddToInfo(TextTO.Text)
            If lRet <> SFCSSENDMAIL_SUCCESS Then
                MsgBox("メモリエラーが発生しました", MsgBoxStyle.Critical, s_cstTITLE)
                Exit Sub
            End If

        End If

        '/////////////////////////////////////////////////////////////
        '// (2)  CC設定
        '//
        '// SFCSSendMailコントロール 《 CCリストリセット 》
        '//   Sub ResetCcInfo()
        '//
        '// SFCSSendMailコントロール 《 CCリスト追加設定 》
        '//   Function AddCcInfo( CcAddress As String ) as Long
        '//

        AxSFCSSendMail1.ResetCcInfo()

        If TextCC.Text <> "" Then

            lRet = AxSFCSSendMail1.AddCcInfo(TextCC.Text)
            If lRet <> SFCSSENDMAIL_SUCCESS Then
                MsgBox("メモリエラーが発生しました", MsgBoxStyle.Critical, s_cstTITLE)
                Exit Sub
            End If

        End If

        '/////////////////////////////////////////////////////////////
        '// (3)  添付ファイル設定
        '//
        '// SFCSSendMailコントロール 《 添付ファイルリストリセット 》
        '//   Sub ResetAttachInfo()
        '//
        '// SFCSSendMailコントロール 《 添付ファイルリスト追加設定 》
        '//   Function AddAttachInfo( AttachName As String ) as Long
        '//

        AxSFCSSendMail1.ResetAttachInfo()

        For i = 1 To 2

            strAttachTEMP = ""

            Select Case i
                Case 1
                    strAttachTEMP = TextATTACH1.Text
                Case 2
                    strAttachTEMP = TextATTACH2.Text
            End Select

            If strAttachTEMP <> "" Then

                lRet = AxSFCSSendMail1.AddAttachInfo(strAttachTEMP)
                If lRet <> SFCSSENDMAIL_SUCCESS Then
                    MsgBox("メモリエラーが発生しました", MsgBoxStyle.Critical, s_cstTITLE)
                    Exit Sub
                End If

            End If
        Next i

        '/////////////////////////////////////////////////////////////
        '// (4)  メール送信命令ファイル作成
        '//
        '// SFCSSendMailコントロール 《 メール送信命令ファイル作成 》
        '//   Function MakeEMailMission( Subject As String,
        '//                              TheBody As String ) as Long
        '//

        lRet = AxSFCSSendMail1.MakeEMailMission(strSubject, strTheBody)

        If lRet = SFCSSENDMAIL_SUCCESS Then
            MsgBox("メール送信命令ファイルを作成しました。", MsgBoxStyle.OkOnly, s_cstTITLE)
        Else
            If lRet = SFCSSENDMAIL_ERR_NoMisFolder Then
                MsgBox("メール送信命令フォルダが存在しません", MsgBoxStyle.Exclamation, s_cstTITLE)
            End If
            If lRet = SFCSSENDMAIL_ERR_GetMisFolder Then
                MsgBox("メール送信命令フォルダの取得に失敗しました", MsgBoxStyle.Exclamation, s_cstTITLE)
            End If
            If lRet = SFCSSENDMAIL_ERR_GetTempFolder Then
                MsgBox("一時フォルダの取得に失敗しました", MsgBoxStyle.Exclamation, s_cstTITLE)
            End If
            If lRet = SFCSSENDMAIL_ERR_GetTempFile Then
                MsgBox("一時ファイルの取得に失敗しました", MsgBoxStyle.Exclamation, s_cstTITLE)
            End If
            If lRet = SFCSSENDMAIL_ERR_MakeMisName Then
                MsgBox("メール送信命令ファイル名の作成に失敗しました", MsgBoxStyle.Exclamation, s_cstTITLE)
            End If
            If lRet = SFCSSENDMAIL_ERR_PARAM_INFO Then
                MsgBox("パラメータエラー: メール送信命令ファイル作成情報が指定されていません。", MsgBoxStyle.Exclamation, s_cstTITLE)
            End If
            If lRet = SFCSSENDMAIL_ERR_PARAM_TO Then
                MsgBox("パラメータエラー: 宛先が指定されていません。", MsgBoxStyle.Exclamation, s_cstTITLE)
            End If
            If lRet = SFCSSENDMAIL_ERR_PARAM_TOADR Then
                MsgBox("パラメータエラー: 宛先アドレスが指定されていません。", MsgBoxStyle.Exclamation, s_cstTITLE)
            End If
            If lRet = SFCSSENDMAIL_ERR_PARAM_CCADR Then
                MsgBox("パラメータエラー: CCアドレスが指定されていません。", MsgBoxStyle.Exclamation, s_cstTITLE)
            End If
            If lRet = SFCSSENDMAIL_ERR_PARAM_ATTACHNAME Then
                MsgBox("パラメータエラー: 添付ファイルパスが指定されていません。", MsgBoxStyle.Exclamation, s_cstTITLE)
            End If
        End If


    End Sub

    '*************************************************************
    ' キャンセルボタン: クリック
    '*************************************************************

    Private Sub CommandCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CommandCancel.Click

        End

    End Sub

    '*************************************************************
    'ファイルオープンダイアログの表示
    '*************************************************************

    Private Function GetOpenFileName(ByRef fileName As String, ByRef filter As String, ByRef title As String) As Boolean
        Dim returnValue As DialogResult
        OpenFileDialog1.FileName = ""
        OpenFileDialog1.Filter = filter
        OpenFileDialog1.Title = title
        OpenFileDialog1.ReadOnlyChecked = False
        OpenFileDialog1.CheckFileExists = True
        returnValue = OpenFileDialog1.ShowDialog
        GetOpenFileName = False
        If returnValue = DialogResult.OK And StrComp(OpenFileDialog1.FileName, "", 1) Then  '入力あり
            fileName = OpenFileDialog1.FileName
            GetOpenFileName = True
        End If
    End Function

    '*************************************************************
    ' 添付ファイル１参照ボタン: クリック
    '*************************************************************

    Private Sub CommandATTACH1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CommandATTACH1.Click

        GetOpenFileName(TextATTACH1.Text, "すべてのファイル(*.*)|*.*", "添付ファイル１")

    End Sub

    '*************************************************************
    ' 添付ファイル２参照ボタン: クリック
    '*************************************************************

    Private Sub CommandATTACH2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CommandATTACH2.Click

        GetOpenFileName(TextATTACH2.Text, "すべてのファイル(*.*)|*.*", "添付ファイル２")

    End Sub
End Class
